//
//  coda.h
//  ASD
//
//  Created by Paolo on 07/11/11.
//  Copyright 2011 IVU Lab. All rights reserved.
//

#ifndef CODAPUNT_H
#define CODAPUNT_H
#include "nodo.h"
using namespace std;

typedef bool boolean;

template <class T>
class Coda{

public:
 	void creaCoda();
 	boolean codaVuota();
 	T leggiCoda();
 	void fuoriCoda();
 	void inCoda(T);
    Coda();
 private:
 	Nodo <T>* testa;
 	Nodo <T>* fondo;
 };

//definizione classe
template <class T>
void Coda<T>::creaCoda () { 
    testa=NULL;
    fondo=NULL;
}

template <class T>
boolean Coda<T>::codaVuota() { 
    return testa==NULL;
}

template <class T>
T Coda<T>::leggiCoda () {
    return testa->elemento;
}

template <class T>
void Coda<T>::inCoda (T a){
	if(codaVuota()){
        fondo=new(Nodo<T>);
        testa=fondo;
    }else{
        fondo->succ=new(Nodo<T>);
        fondo=fondo->succ;
    }
    fondo->elemento=a;
    fondo->succ=NULL;
}

template <class T>
void Coda<T>::fuoriCoda(){
	Nodo <T> * temp;
	if (!codaVuota()){
		temp=testa;
		testa=testa->succ;
   	    delete temp;
	}
}

template <class T>
Coda<T>::Coda() {
    creaCoda();
}

#endif //CODA_PUNT_H

