//
//  lista.h
//  ASD
//
//  Created by Paolo on 07/11/11.
//  Copyright 2011 IVU Lab. All rights reserved.
//

#ifndef lista_h
#define lista_h
#include <cstdlib>
#include <iostream>
#include "nodo.h"
#include "persone.h"

using namespace std;

typedef bool boolean;

template <class T>
class Lista{

public:
    typedef Nodo <T> * posizione;
    Lista();   
    void creaLista ();
    boolean listaVuota();
    T leggiLista(posizione);
    void scriviLista(T,posizione);
    void insLista(T, posizione&);
    posizione primoLista();
    boolean fineLista(posizione);
    posizione succLista(posizione);
    posizione predLista(posizione);
    void cancLista(posizione);
    
private:
    posizione testa;
};

template <class T> 
Lista<T>::Lista(){
    creaLista();                           
}

template <class T> 
void Lista<T>::creaLista (){
    testa=NULL;
}

template <class T> 
boolean Lista<T>::listaVuota(){
    return (testa==NULL);
}

template <class T>
T Lista<T>::leggiLista(posizione p){
    return p->elemento;
}

template <class T>
void Lista<T>::scriviLista(T t,posizione p){
    p->elemento=t;
}

template <class T>
    Nodo <T> * Lista<T>::primoLista(){
    return testa;
}

template <class T>
void Lista<T>::insLista(T t, posizione &p){
    Nodo<T> * temp = new Nodo<T>();
    temp->elemento = t;
    temp->succ=p;
        if (p==primoLista()) {
            testa=temp;
        }else{
            posizione prec=predLista(p);
            prec->succ=temp;
        }
}

template <class T>
boolean Lista<T>::fineLista(posizione p){
    return (p==NULL)?true:false;//todo: da specifiche è vero se è oltre l'ultimo elemento (n+1) 
}

template <class T>
Nodo <T> * Lista<T>::succLista(posizione p){
    return p->succ;
}

template <class T>
Nodo <T> * Lista<T>::predLista(posizione p){
    posizione p1=primoLista();
    while (!fineLista(p1) && (p1->succ != p)) {
        p1=succLista(p1);
    }
    return p1;
}

#endif //lista_h